---
---
<!-- HTML header for doxygen 1.8.10-->
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.11"/>
<title>TGUI: include/TGUI/Texture.hpp Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<script type="text/javascript">
  $(document).ready(function() { init_search(); });
</script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
<!-- BEGIN CUSTOM 1 -->
<!-- --{{""}}>
{% include head.ext %}
<style>
  div {
    margin-bottom: 0
  }
  #contents {
    padding-left: 0;
    padding-right: 0;
    margin-left: 0;
    margin-right: 0;
    max-width: 1060px;
  }
  address.footer {
    padding-bottom: 1.4em;
  }
</style>
<script type="text/javascript">
function getXPos(item) {
  var x = 0;
  if (item.offsetWidth) {
    while (item && item != document.body && item.id != 'body') {
      x   += item.offsetLeft;
      item = item.offsetParent;
    }
  }
  return x;
}
</script>
<{{""}}!-- -->
<!-- END CUSTOM 1 -->
</head>
<body>
<!-- BEGIN CUSTOM 2 -->
<!-- --{{""}}>
<div id="body" class="NoMargin">
{% include navigation.ext %}
<div id="contents" class="NoMargin">
<{{""}}!-- {% raw %} -->
<!-- END CUSTOM 2 -->
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">TGUI
   &#160;<span id="projectnumber">v0.7-dev</span>
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.11 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "search",false,'Search');
</script>
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li>
        <div id="MSearchBox" class="MSearchBoxInactive">
        <span class="left">
          <img id="MSearchSelect" src="search/mag_sel.png"
               onmouseover="return searchBox.OnSearchSelectShow()"
               onmouseout="return searchBox.OnSearchSelectHide()"
               alt=""/>
          <input type="text" id="MSearchField" value="Search" accesskey="S"
               onfocus="searchBox.OnSearchFieldFocus(true)" 
               onblur="searchBox.OnSearchFieldFocus(false)" 
               onkeyup="searchBox.OnSearchFieldChange(event)"/>
          </span><span class="right">
            <a id="MSearchClose" href="javascript:searchBox.CloseResultsWindow()"><img id="MSearchCloseImg" border="0" src="search/close.png" alt=""/></a>
          </span>
        </div>
      </li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
    </ul>
  </div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="dir_d44c64559bbebec7f509842c48db8b23.html">include</a></li><li class="navelem"><a class="el" href="dir_380f920385a16f176be7632160138052.html">TGUI</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="headertitle">
<div class="title">Texture.hpp</div>  </div>
</div><!--header-->
<div class="contents">
<div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="comment">//</span></div><div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;<span class="comment">// TGUI - Texus&#39;s Graphical User Interface</span></div><div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="comment">// Copyright (C) 2012-2017 Bruno Van de Velde (vdv_b@tgui.eu)</span></div><div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160;<span class="comment">//</span></div><div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160;<span class="comment">// This software is provided &#39;as-is&#39;, without any express or implied warranty.</span></div><div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160;<span class="comment">// In no event will the authors be held liable for any damages arising from the use of this software.</span></div><div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160;<span class="comment">//</span></div><div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160;<span class="comment">// Permission is granted to anyone to use this software for any purpose,</span></div><div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160;<span class="comment">// including commercial applications, and to alter it and redistribute it freely,</span></div><div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160;<span class="comment">// subject to the following restrictions:</span></div><div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160;<span class="comment">//</span></div><div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160;<span class="comment">// 1. The origin of this software must not be misrepresented;</span></div><div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160;<span class="comment">//    you must not claim that you wrote the original software.</span></div><div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160;<span class="comment">//    If you use this software in a product, an acknowledgment</span></div><div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160;<span class="comment">//    in the product documentation would be appreciated but is not required.</span></div><div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160;<span class="comment">//</span></div><div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160;<span class="comment">// 2. Altered source versions must be plainly marked as such,</span></div><div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160;<span class="comment">//    and must not be misrepresented as being the original software.</span></div><div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160;<span class="comment">//</span></div><div class="line"><a name="l00021"></a><span class="lineno">   21</span>&#160;<span class="comment">// 3. This notice may not be removed or altered from any source distribution.</span></div><div class="line"><a name="l00022"></a><span class="lineno">   22</span>&#160;<span class="comment">//</span></div><div class="line"><a name="l00024"></a><span class="lineno">   24</span>&#160;<span class="comment"></span></div><div class="line"><a name="l00025"></a><span class="lineno">   25</span>&#160;</div><div class="line"><a name="l00026"></a><span class="lineno">   26</span>&#160;<span class="preprocessor">#ifndef TGUI_TEXTURE_HPP</span></div><div class="line"><a name="l00027"></a><span class="lineno">   27</span>&#160;<span class="preprocessor">#define TGUI_TEXTURE_HPP</span></div><div class="line"><a name="l00028"></a><span class="lineno">   28</span>&#160;</div><div class="line"><a name="l00030"></a><span class="lineno">   30</span>&#160;</div><div class="line"><a name="l00031"></a><span class="lineno">   31</span>&#160;<span class="preprocessor">#include &lt;TGUI/TextureData.hpp&gt;</span></div><div class="line"><a name="l00032"></a><span class="lineno">   32</span>&#160;<span class="preprocessor">#include &lt;TGUI/TextureManager.hpp&gt;</span></div><div class="line"><a name="l00033"></a><span class="lineno">   33</span>&#160;</div><div class="line"><a name="l00034"></a><span class="lineno">   34</span>&#160;<span class="preprocessor">#include &lt;TGUI/Global.hpp&gt;</span></div><div class="line"><a name="l00035"></a><span class="lineno">   35</span>&#160;</div><div class="line"><a name="l00036"></a><span class="lineno">   36</span>&#160;<span class="preprocessor">#include &lt;functional&gt;</span></div><div class="line"><a name="l00037"></a><span class="lineno">   37</span>&#160;</div><div class="line"><a name="l00039"></a><span class="lineno">   39</span>&#160;</div><div class="line"><a name="l00040"></a><span class="lineno">   40</span>&#160;<span class="keyword">namespace </span><a class="code" href="namespacetgui.html">tgui</a></div><div class="line"><a name="l00041"></a><span class="lineno">   41</span>&#160;{</div><div class="line"><a name="l00043"></a><span class="lineno">   43</span>&#160;</div><div class="line"><a name="l00044"></a><span class="lineno"><a class="line" href="classtgui_1_1Texture.html">   44</a></span>&#160;    <span class="keyword">class </span>TGUI_API <a class="code" href="classtgui_1_1Texture.html">Texture</a> : <span class="keyword">public</span> sf::Transformable, <span class="keyword">public</span> sf::Drawable</div><div class="line"><a name="l00045"></a><span class="lineno">   45</span>&#160;    {</div><div class="line"><a name="l00046"></a><span class="lineno">   46</span>&#160;    <span class="keyword">public</span>:</div><div class="line"><a name="l00047"></a><span class="lineno">   47</span>&#160;</div><div class="line"><a name="l00048"></a><span class="lineno">   48</span>&#160;        <span class="keyword">using</span> ImageLoaderFunc = std::function&lt;std::shared_ptr&lt;sf::Image&gt;(<span class="keyword">const</span> sf::String&amp;)&gt;;</div><div class="line"><a name="l00049"></a><span class="lineno">   49</span>&#160;        <span class="keyword">using</span> TextureLoaderFunc = std::function&lt;bool(Texture&amp;, const sf::String&amp;, const sf::IntRect&amp;)&gt;;</div><div class="line"><a name="l00050"></a><span class="lineno">   50</span>&#160;</div><div class="line"><a name="l00051"></a><span class="lineno">   51</span>&#160;</div><div class="line"><a name="l00056"></a><span class="lineno"><a class="line" href="classtgui_1_1Texture.html#aaba70370fcc0e5fe13508646d2300014">   56</a></span>&#160;        <span class="keyword">enum class</span> <a class="code" href="classtgui_1_1Texture.html#aaba70370fcc0e5fe13508646d2300014">ScalingType</a></div><div class="line"><a name="l00057"></a><span class="lineno">   57</span>&#160;        {</div><div class="line"><a name="l00058"></a><span class="lineno">   58</span>&#160;            Normal,     </div><div class="line"><a name="l00059"></a><span class="lineno">   59</span>&#160;            Horizontal, </div><div class="line"><a name="l00060"></a><span class="lineno">   60</span>&#160;            Vertical,   </div><div class="line"><a name="l00061"></a><span class="lineno">   61</span>&#160;            NineSlice   </div><div class="line"><a name="l00062"></a><span class="lineno">   62</span>&#160;        };</div><div class="line"><a name="l00063"></a><span class="lineno">   63</span>&#160;</div><div class="line"><a name="l00064"></a><span class="lineno">   64</span>&#160;</div><div class="line"><a name="l00066"></a><span class="lineno">   66</span>&#160;    <span class="keyword">public</span>:</div><div class="line"><a name="l00067"></a><span class="lineno">   67</span>&#160;</div><div class="line"><a name="l00072"></a><span class="lineno"><a class="line" href="classtgui_1_1Texture.html#aa62ae5c1e87888eee4f52cc9622e813b">   72</a></span>&#160;        <a class="code" href="classtgui_1_1Texture.html#aa62ae5c1e87888eee4f52cc9622e813b">Texture</a>() {}</div><div class="line"><a name="l00073"></a><span class="lineno">   73</span>&#160;</div><div class="line"><a name="l00074"></a><span class="lineno">   74</span>&#160;</div><div class="line"><a name="l00085"></a><span class="lineno">   85</span>&#160;        <a class="code" href="classtgui_1_1Texture.html">Texture</a>(<span class="keyword">const</span> sf::String&amp; <span class="keywordtype">id</span>,</div><div class="line"><a name="l00086"></a><span class="lineno">   86</span>&#160;                <span class="keyword">const</span> sf::IntRect&amp; partRect = sf::IntRect(0, 0, 0, 0),</div><div class="line"><a name="l00087"></a><span class="lineno">   87</span>&#160;                <span class="keyword">const</span> sf::IntRect&amp; middlePart = sf::IntRect(0, 0, 0, 0));</div><div class="line"><a name="l00088"></a><span class="lineno">   88</span>&#160;</div><div class="line"><a name="l00089"></a><span class="lineno">   89</span>&#160;</div><div class="line"><a name="l00102"></a><span class="lineno">  102</span>&#160;        <a class="code" href="classtgui_1_1Texture.html">Texture</a>(<span class="keyword">const</span> sf::Texture&amp; texture,</div><div class="line"><a name="l00103"></a><span class="lineno">  103</span>&#160;                <span class="keyword">const</span> sf::IntRect&amp; partRect = sf::IntRect(0, 0, 0, 0),</div><div class="line"><a name="l00104"></a><span class="lineno">  104</span>&#160;                <span class="keyword">const</span> sf::IntRect&amp; middlePart = sf::IntRect(0, 0, 0, 0));</div><div class="line"><a name="l00105"></a><span class="lineno">  105</span>&#160;</div><div class="line"><a name="l00106"></a><span class="lineno">  106</span>&#160;</div><div class="line"><a name="l00113"></a><span class="lineno">  113</span>&#160;        <a class="code" href="classtgui_1_1Texture.html">Texture</a>(<span class="keyword">const</span> <a class="code" href="classtgui_1_1Texture.html">Texture</a>&amp; texture);</div><div class="line"><a name="l00114"></a><span class="lineno">  114</span>&#160;</div><div class="line"><a name="l00115"></a><span class="lineno">  115</span>&#160;</div><div class="line"><a name="l00117"></a><span class="lineno">  117</span>&#160;        <span class="comment">// Virtual destructor</span></div><div class="line"><a name="l00119"></a><span class="lineno">  119</span>&#160;<span class="comment"></span>        ~<a class="code" href="classtgui_1_1Texture.html">Texture</a>();</div><div class="line"><a name="l00120"></a><span class="lineno">  120</span>&#160;</div><div class="line"><a name="l00121"></a><span class="lineno">  121</span>&#160;</div><div class="line"><a name="l00130"></a><span class="lineno">  130</span>&#160;        <a class="code" href="classtgui_1_1Texture.html">Texture</a>&amp; operator=(<span class="keyword">const</span> <a class="code" href="classtgui_1_1Texture.html">Texture</a>&amp; right);</div><div class="line"><a name="l00131"></a><span class="lineno">  131</span>&#160;</div><div class="line"><a name="l00132"></a><span class="lineno">  132</span>&#160;</div><div class="line"><a name="l00143"></a><span class="lineno">  143</span>&#160;        <span class="keywordtype">void</span> load(<span class="keyword">const</span> sf::Texture&amp; texture,</div><div class="line"><a name="l00144"></a><span class="lineno">  144</span>&#160;                  <span class="keyword">const</span> sf::IntRect&amp; partRect = {},</div><div class="line"><a name="l00145"></a><span class="lineno">  145</span>&#160;                  <span class="keyword">const</span> sf::IntRect&amp; middleRect = {});</div><div class="line"><a name="l00146"></a><span class="lineno">  146</span>&#160;</div><div class="line"><a name="l00147"></a><span class="lineno">  147</span>&#160;</div><div class="line"><a name="l00156"></a><span class="lineno">  156</span>&#160;        <span class="keywordtype">void</span> load(<span class="keyword">const</span> sf::String&amp; <span class="keywordtype">id</span>,</div><div class="line"><a name="l00157"></a><span class="lineno">  157</span>&#160;                  <span class="keyword">const</span> sf::IntRect&amp; partRect = {},</div><div class="line"><a name="l00158"></a><span class="lineno">  158</span>&#160;                  <span class="keyword">const</span> sf::IntRect&amp; middleRect = {});</div><div class="line"><a name="l00159"></a><span class="lineno">  159</span>&#160;</div><div class="line"><a name="l00160"></a><span class="lineno">  160</span>&#160;</div><div class="line"><a name="l00170"></a><span class="lineno">  170</span>&#160;        <span class="keywordtype">void</span> setTexture(std::shared_ptr&lt;TextureData&gt; data, <span class="keyword">const</span> sf::IntRect&amp; middleRect = {});</div><div class="line"><a name="l00171"></a><span class="lineno">  171</span>&#160;</div><div class="line"><a name="l00172"></a><span class="lineno">  172</span>&#160;</div><div class="line"><a name="l00179"></a><span class="lineno">  179</span>&#160;        std::string getId() <span class="keyword">const</span>;</div><div class="line"><a name="l00180"></a><span class="lineno">  180</span>&#160;</div><div class="line"><a name="l00181"></a><span class="lineno">  181</span>&#160;</div><div class="line"><a name="l00188"></a><span class="lineno">  188</span>&#160;        std::shared_ptr&lt;TextureData&gt;&amp; getData();</div><div class="line"><a name="l00189"></a><span class="lineno">  189</span>&#160;</div><div class="line"><a name="l00190"></a><span class="lineno">  190</span>&#160;</div><div class="line"><a name="l00197"></a><span class="lineno">  197</span>&#160;        std::shared_ptr&lt;const TextureData&gt; getData() <span class="keyword">const</span>;</div><div class="line"><a name="l00198"></a><span class="lineno">  198</span>&#160;</div><div class="line"><a name="l00199"></a><span class="lineno">  199</span>&#160;</div><div class="line"><a name="l00206"></a><span class="lineno">  206</span>&#160;        <span class="keywordtype">void</span> setSize(<span class="keyword">const</span> sf::Vector2f&amp; size);</div><div class="line"><a name="l00207"></a><span class="lineno">  207</span>&#160;</div><div class="line"><a name="l00208"></a><span class="lineno">  208</span>&#160;</div><div class="line"><a name="l00215"></a><span class="lineno"><a class="line" href="classtgui_1_1Texture.html#acea39d21c2435bb370f0727afd341352">  215</a></span>&#160;        sf::Vector2f <a class="code" href="classtgui_1_1Texture.html#acea39d21c2435bb370f0727afd341352">getSize</a>()<span class="keyword"> const</span></div><div class="line"><a name="l00216"></a><span class="lineno">  216</span>&#160;<span class="keyword">        </span>{</div><div class="line"><a name="l00217"></a><span class="lineno">  217</span>&#160;            <span class="keywordflow">return</span> m_size;</div><div class="line"><a name="l00218"></a><span class="lineno">  218</span>&#160;        }</div><div class="line"><a name="l00219"></a><span class="lineno">  219</span>&#160;</div><div class="line"><a name="l00220"></a><span class="lineno">  220</span>&#160;</div><div class="line"><a name="l00227"></a><span class="lineno"><a class="line" href="classtgui_1_1Texture.html#aea07cdfdda3e2c773552ededfd6e26b9">  227</a></span>&#160;        sf::Vector2f <a class="code" href="classtgui_1_1Texture.html#aea07cdfdda3e2c773552ededfd6e26b9">getImageSize</a>()<span class="keyword"> const</span></div><div class="line"><a name="l00228"></a><span class="lineno">  228</span>&#160;<span class="keyword">        </span>{</div><div class="line"><a name="l00229"></a><span class="lineno">  229</span>&#160;            <span class="keywordflow">return</span> sf::Vector2f{m_data-&gt;texture.getSize()};</div><div class="line"><a name="l00230"></a><span class="lineno">  230</span>&#160;        }</div><div class="line"><a name="l00231"></a><span class="lineno">  231</span>&#160;</div><div class="line"><a name="l00232"></a><span class="lineno">  232</span>&#160;</div><div class="line"><a name="l00244"></a><span class="lineno">  244</span>&#160;        <span class="keywordtype">void</span> setColor(<span class="keyword">const</span> sf::Color&amp; color);</div><div class="line"><a name="l00245"></a><span class="lineno">  245</span>&#160;</div><div class="line"><a name="l00246"></a><span class="lineno">  246</span>&#160;</div><div class="line"><a name="l00258"></a><span class="lineno">  258</span>&#160;        <span class="keyword">const</span> sf::Color&amp; getColor() <span class="keyword">const</span>;</div><div class="line"><a name="l00259"></a><span class="lineno">  259</span>&#160;</div><div class="line"><a name="l00260"></a><span class="lineno">  260</span>&#160;</div><div class="line"><a name="l00269"></a><span class="lineno"><a class="line" href="classtgui_1_1Texture.html#a8ddbe2a731d9fc38296ec10a3154f853">  269</a></span>&#160;        <span class="keywordtype">void</span> <a class="code" href="classtgui_1_1Texture.html#a8ddbe2a731d9fc38296ec10a3154f853">setTextureRect</a>(<span class="keyword">const</span> sf::FloatRect&amp; textureRect)</div><div class="line"><a name="l00270"></a><span class="lineno">  270</span>&#160;        {</div><div class="line"><a name="l00271"></a><span class="lineno">  271</span>&#160;            m_textureRect = textureRect;</div><div class="line"><a name="l00272"></a><span class="lineno">  272</span>&#160;        }</div><div class="line"><a name="l00273"></a><span class="lineno">  273</span>&#160;</div><div class="line"><a name="l00274"></a><span class="lineno">  274</span>&#160;</div><div class="line"><a name="l00281"></a><span class="lineno"><a class="line" href="classtgui_1_1Texture.html#aa26d635449a54dc8a325a5ebd889416e">  281</a></span>&#160;        sf::FloatRect <a class="code" href="classtgui_1_1Texture.html#aa26d635449a54dc8a325a5ebd889416e">getTextureRect</a>()<span class="keyword"> const</span></div><div class="line"><a name="l00282"></a><span class="lineno">  282</span>&#160;<span class="keyword">        </span>{</div><div class="line"><a name="l00283"></a><span class="lineno">  283</span>&#160;            <span class="keywordflow">return</span> m_textureRect;</div><div class="line"><a name="l00284"></a><span class="lineno">  284</span>&#160;        }</div><div class="line"><a name="l00285"></a><span class="lineno">  285</span>&#160;</div><div class="line"><a name="l00286"></a><span class="lineno">  286</span>&#160;</div><div class="line"><a name="l00293"></a><span class="lineno"><a class="line" href="classtgui_1_1Texture.html#a199b6fbd749dbfd5e000ac9714d7f096">  293</a></span>&#160;        sf::IntRect <a class="code" href="classtgui_1_1Texture.html#a199b6fbd749dbfd5e000ac9714d7f096">getMiddleRect</a>()<span class="keyword"> const</span></div><div class="line"><a name="l00294"></a><span class="lineno">  294</span>&#160;<span class="keyword">        </span>{</div><div class="line"><a name="l00295"></a><span class="lineno">  295</span>&#160;            <span class="keywordflow">return</span> m_middleRect;</div><div class="line"><a name="l00296"></a><span class="lineno">  296</span>&#160;        }</div><div class="line"><a name="l00297"></a><span class="lineno">  297</span>&#160;</div><div class="line"><a name="l00298"></a><span class="lineno">  298</span>&#160;</div><div class="line"><a name="l00311"></a><span class="lineno">  311</span>&#160;        <span class="keywordtype">void</span> setSmooth(<span class="keywordtype">bool</span> smooth);</div><div class="line"><a name="l00312"></a><span class="lineno">  312</span>&#160;</div><div class="line"><a name="l00313"></a><span class="lineno">  313</span>&#160;</div><div class="line"><a name="l00322"></a><span class="lineno"><a class="line" href="classtgui_1_1Texture.html#aa434c72adfabf617afb06772960cc0f9">  322</a></span>&#160;        <span class="keywordtype">bool</span> <a class="code" href="classtgui_1_1Texture.html#aa434c72adfabf617afb06772960cc0f9">isSmooth</a>()<span class="keyword"> const</span></div><div class="line"><a name="l00323"></a><span class="lineno">  323</span>&#160;<span class="keyword">        </span>{</div><div class="line"><a name="l00324"></a><span class="lineno">  324</span>&#160;            <span class="keywordflow">return</span> m_data-&gt;texture.isSmooth();</div><div class="line"><a name="l00325"></a><span class="lineno">  325</span>&#160;        }</div><div class="line"><a name="l00326"></a><span class="lineno">  326</span>&#160;</div><div class="line"><a name="l00327"></a><span class="lineno">  327</span>&#160;</div><div class="line"><a name="l00337"></a><span class="lineno">  337</span>&#160;        <span class="keywordtype">bool</span> isTransparentPixel(<span class="keywordtype">float</span> x, <span class="keywordtype">float</span> y) <span class="keyword">const</span>;</div><div class="line"><a name="l00338"></a><span class="lineno">  338</span>&#160;</div><div class="line"><a name="l00339"></a><span class="lineno">  339</span>&#160;</div><div class="line"><a name="l00346"></a><span class="lineno"><a class="line" href="classtgui_1_1Texture.html#a90a5e1461403267d9cc370df16b34ba0">  346</a></span>&#160;        <a class="code" href="classtgui_1_1Texture.html#aaba70370fcc0e5fe13508646d2300014">ScalingType</a> <a class="code" href="classtgui_1_1Texture.html#a90a5e1461403267d9cc370df16b34ba0">getScalingType</a>()<span class="keyword"> const</span></div><div class="line"><a name="l00347"></a><span class="lineno">  347</span>&#160;<span class="keyword">        </span>{</div><div class="line"><a name="l00348"></a><span class="lineno">  348</span>&#160;            <span class="keywordflow">return</span> m_scalingType;</div><div class="line"><a name="l00349"></a><span class="lineno">  349</span>&#160;        }</div><div class="line"><a name="l00350"></a><span class="lineno">  350</span>&#160;</div><div class="line"><a name="l00351"></a><span class="lineno">  351</span>&#160;</div><div class="line"><a name="l00358"></a><span class="lineno"><a class="line" href="classtgui_1_1Texture.html#adb79cf4d9168fcdfcbadd5c4357a4249">  358</a></span>&#160;        <span class="keywordtype">bool</span> <a class="code" href="classtgui_1_1Texture.html#adb79cf4d9168fcdfcbadd5c4357a4249">isLoaded</a>()<span class="keyword"> const</span></div><div class="line"><a name="l00359"></a><span class="lineno">  359</span>&#160;<span class="keyword">        </span>{</div><div class="line"><a name="l00360"></a><span class="lineno">  360</span>&#160;            <span class="keywordflow">return</span> m_loaded;</div><div class="line"><a name="l00361"></a><span class="lineno">  361</span>&#160;        }</div><div class="line"><a name="l00362"></a><span class="lineno">  362</span>&#160;</div><div class="line"><a name="l00363"></a><span class="lineno">  363</span>&#160;</div><div class="line"><a name="l00374"></a><span class="lineno">  374</span>&#160;        <span class="keyword">static</span> <span class="keywordtype">void</span> setImageLoader(<span class="keyword">const</span> ImageLoaderFunc&amp; func);</div><div class="line"><a name="l00375"></a><span class="lineno">  375</span>&#160;</div><div class="line"><a name="l00376"></a><span class="lineno">  376</span>&#160;</div><div class="line"><a name="l00387"></a><span class="lineno">  387</span>&#160;        <span class="keyword">static</span> <span class="keywordtype">void</span> setTextureLoader(<span class="keyword">const</span> TextureLoaderFunc&amp; func);</div><div class="line"><a name="l00388"></a><span class="lineno">  388</span>&#160;</div><div class="line"><a name="l00389"></a><span class="lineno">  389</span>&#160;</div><div class="line"><a name="l00398"></a><span class="lineno">  398</span>&#160;        <span class="keyword">static</span> ImageLoaderFunc getImageLoader();</div><div class="line"><a name="l00399"></a><span class="lineno">  399</span>&#160;</div><div class="line"><a name="l00400"></a><span class="lineno">  400</span>&#160;</div><div class="line"><a name="l00409"></a><span class="lineno">  409</span>&#160;        <span class="keyword">static</span> TextureLoaderFunc getTextureLoader();</div><div class="line"><a name="l00410"></a><span class="lineno">  410</span>&#160;</div><div class="line"><a name="l00411"></a><span class="lineno">  411</span>&#160;</div><div class="line"><a name="l00420"></a><span class="lineno">  420</span>&#160;        <span class="keywordtype">void</span> setCopyCallback(<span class="keyword">const</span> std::function&lt;<span class="keywordtype">void</span>(std::shared_ptr&lt;TextureData&gt;)&gt; func);</div><div class="line"><a name="l00421"></a><span class="lineno">  421</span>&#160;</div><div class="line"><a name="l00422"></a><span class="lineno">  422</span>&#160;</div><div class="line"><a name="l00431"></a><span class="lineno">  431</span>&#160;        <span class="keywordtype">void</span> setDestructCallback(<span class="keyword">const</span> std::function&lt;<span class="keywordtype">void</span>(std::shared_ptr&lt;TextureData&gt;)&gt; func);</div><div class="line"><a name="l00432"></a><span class="lineno">  432</span>&#160;</div><div class="line"><a name="l00433"></a><span class="lineno">  433</span>&#160;</div><div class="line"><a name="l00434"></a><span class="lineno">  434</span>&#160;</div><div class="line"><a name="l00436"></a><span class="lineno">  436</span>&#160;    <span class="keyword">private</span>:</div><div class="line"><a name="l00437"></a><span class="lineno">  437</span>&#160;</div><div class="line"><a name="l00439"></a><span class="lineno">  439</span>&#160;        <span class="comment">// Update the vertices of the internal vertex array</span></div><div class="line"><a name="l00441"></a><span class="lineno">  441</span>&#160;<span class="comment"></span>        <span class="keywordtype">void</span> updateVertices();</div><div class="line"><a name="l00442"></a><span class="lineno">  442</span>&#160;</div><div class="line"><a name="l00443"></a><span class="lineno">  443</span>&#160;</div><div class="line"><a name="l00445"></a><span class="lineno">  445</span>&#160;        <span class="comment">// Draws the texture</span></div><div class="line"><a name="l00447"></a><span class="lineno">  447</span>&#160;<span class="comment"></span>        <span class="keywordtype">void</span> draw(sf::RenderTarget&amp; target, sf::RenderStates states) <span class="keyword">const override</span>;</div><div class="line"><a name="l00448"></a><span class="lineno">  448</span>&#160;</div><div class="line"><a name="l00449"></a><span class="lineno">  449</span>&#160;</div><div class="line"><a name="l00451"></a><span class="lineno">  451</span>&#160;</div><div class="line"><a name="l00452"></a><span class="lineno">  452</span>&#160;    <span class="keyword">private</span>:</div><div class="line"><a name="l00453"></a><span class="lineno">  453</span>&#160;        std::shared_ptr&lt;TextureData&gt; m_data = std::make_shared&lt;TextureData&gt;();</div><div class="line"><a name="l00454"></a><span class="lineno">  454</span>&#160;        std::vector&lt;sf::Vertex&gt; m_vertices;</div><div class="line"><a name="l00455"></a><span class="lineno">  455</span>&#160;</div><div class="line"><a name="l00456"></a><span class="lineno">  456</span>&#160;        sf::Vector2f  m_size;</div><div class="line"><a name="l00457"></a><span class="lineno">  457</span>&#160;        sf::IntRect   m_middleRect;</div><div class="line"><a name="l00458"></a><span class="lineno">  458</span>&#160;        sf::FloatRect m_textureRect;</div><div class="line"><a name="l00459"></a><span class="lineno">  459</span>&#160;        sf::Color     m_vertexColor = sf::Color::White;</div><div class="line"><a name="l00460"></a><span class="lineno">  460</span>&#160;</div><div class="line"><a name="l00461"></a><span class="lineno">  461</span>&#160;        <a class="code" href="classtgui_1_1Texture.html#aaba70370fcc0e5fe13508646d2300014">ScalingType</a>   m_scalingType = ScalingType::Normal;</div><div class="line"><a name="l00462"></a><span class="lineno">  462</span>&#160;</div><div class="line"><a name="l00463"></a><span class="lineno">  463</span>&#160;        <span class="keywordtype">bool</span> m_loaded = <span class="keyword">false</span>;</div><div class="line"><a name="l00464"></a><span class="lineno">  464</span>&#160;        std::string m_id;</div><div class="line"><a name="l00465"></a><span class="lineno">  465</span>&#160;</div><div class="line"><a name="l00466"></a><span class="lineno">  466</span>&#160;        std::function&lt;void(std::shared_ptr&lt;TextureData&gt;)&gt; m_copyCallback;</div><div class="line"><a name="l00467"></a><span class="lineno">  467</span>&#160;        std::function&lt;void(std::shared_ptr&lt;TextureData&gt;)&gt; m_destructCallback;</div><div class="line"><a name="l00468"></a><span class="lineno">  468</span>&#160;        <span class="keyword">static</span> TextureLoaderFunc m_textureLoader;</div><div class="line"><a name="l00469"></a><span class="lineno">  469</span>&#160;        <span class="keyword">static</span> ImageLoaderFunc m_imageLoader;</div><div class="line"><a name="l00470"></a><span class="lineno">  470</span>&#160;    };</div><div class="line"><a name="l00471"></a><span class="lineno">  471</span>&#160;</div><div class="line"><a name="l00473"></a><span class="lineno">  473</span>&#160;}</div><div class="line"><a name="l00474"></a><span class="lineno">  474</span>&#160;</div><div class="line"><a name="l00476"></a><span class="lineno">  476</span>&#160;</div><div class="line"><a name="l00477"></a><span class="lineno">  477</span>&#160;<span class="preprocessor">#endif // TGUI_TEXTURE_HPP</span></div><div class="ttc" id="namespacetgui_html"><div class="ttname"><a href="namespacetgui.html">tgui</a></div><div class="ttdoc">Namespace that contains all TGUI functions and classes. </div><div class="ttdef"><b>Definition:</b> Animation.hpp:33</div></div>
<div class="ttc" id="classtgui_1_1Texture_html_aa62ae5c1e87888eee4f52cc9622e813b"><div class="ttname"><a href="classtgui_1_1Texture.html#aa62ae5c1e87888eee4f52cc9622e813b">tgui::Texture::Texture</a></div><div class="ttdeci">Texture()</div><div class="ttdoc">Default constructor. </div><div class="ttdef"><b>Definition:</b> Texture.hpp:72</div></div>
<div class="ttc" id="classtgui_1_1Texture_html_acea39d21c2435bb370f0727afd341352"><div class="ttname"><a href="classtgui_1_1Texture.html#acea39d21c2435bb370f0727afd341352">tgui::Texture::getSize</a></div><div class="ttdeci">sf::Vector2f getSize() const </div><div class="ttdoc">Returns the size that the image has when drawing. </div><div class="ttdef"><b>Definition:</b> Texture.hpp:215</div></div>
<div class="ttc" id="classtgui_1_1Texture_html_aa26d635449a54dc8a325a5ebd889416e"><div class="ttname"><a href="classtgui_1_1Texture.html#aa26d635449a54dc8a325a5ebd889416e">tgui::Texture::getTextureRect</a></div><div class="ttdeci">sf::FloatRect getTextureRect() const </div><div class="ttdoc">Returns the part of the texture that is drawn. </div><div class="ttdef"><b>Definition:</b> Texture.hpp:281</div></div>
<div class="ttc" id="classtgui_1_1Texture_html_aea07cdfdda3e2c773552ededfd6e26b9"><div class="ttname"><a href="classtgui_1_1Texture.html#aea07cdfdda3e2c773552ededfd6e26b9">tgui::Texture::getImageSize</a></div><div class="ttdeci">sf::Vector2f getImageSize() const </div><div class="ttdoc">Returns the size that the loaded image. </div><div class="ttdef"><b>Definition:</b> Texture.hpp:227</div></div>
<div class="ttc" id="classtgui_1_1Texture_html_adb79cf4d9168fcdfcbadd5c4357a4249"><div class="ttname"><a href="classtgui_1_1Texture.html#adb79cf4d9168fcdfcbadd5c4357a4249">tgui::Texture::isLoaded</a></div><div class="ttdeci">bool isLoaded() const </div><div class="ttdoc">Check if the texture has been correctly loaded. </div><div class="ttdef"><b>Definition:</b> Texture.hpp:358</div></div>
<div class="ttc" id="classtgui_1_1Texture_html_aaba70370fcc0e5fe13508646d2300014"><div class="ttname"><a href="classtgui_1_1Texture.html#aaba70370fcc0e5fe13508646d2300014">tgui::Texture::ScalingType</a></div><div class="ttdeci">ScalingType</div><div class="ttdoc">The way the image should be scaled. </div><div class="ttdef"><b>Definition:</b> Texture.hpp:56</div></div>
<div class="ttc" id="classtgui_1_1Texture_html_a199b6fbd749dbfd5e000ac9714d7f096"><div class="ttname"><a href="classtgui_1_1Texture.html#a199b6fbd749dbfd5e000ac9714d7f096">tgui::Texture::getMiddleRect</a></div><div class="ttdeci">sf::IntRect getMiddleRect() const </div><div class="ttdoc">Returns the middle rect of the texture which is used for 9-slice scaling. </div><div class="ttdef"><b>Definition:</b> Texture.hpp:293</div></div>
<div class="ttc" id="classtgui_1_1Texture_html"><div class="ttname"><a href="classtgui_1_1Texture.html">tgui::Texture</a></div><div class="ttdef"><b>Definition:</b> Texture.hpp:44</div></div>
<div class="ttc" id="classtgui_1_1Texture_html_a8ddbe2a731d9fc38296ec10a3154f853"><div class="ttname"><a href="classtgui_1_1Texture.html#a8ddbe2a731d9fc38296ec10a3154f853">tgui::Texture::setTextureRect</a></div><div class="ttdeci">void setTextureRect(const sf::FloatRect &amp;textureRect)</div><div class="ttdoc">Changes the part of the texture that should be drawn. </div><div class="ttdef"><b>Definition:</b> Texture.hpp:269</div></div>
<div class="ttc" id="classtgui_1_1Texture_html_a90a5e1461403267d9cc370df16b34ba0"><div class="ttname"><a href="classtgui_1_1Texture.html#a90a5e1461403267d9cc370df16b34ba0">tgui::Texture::getScalingType</a></div><div class="ttdeci">ScalingType getScalingType() const </div><div class="ttdoc">Returns the way in which the image is being scaled. </div><div class="ttdef"><b>Definition:</b> Texture.hpp:346</div></div>
<div class="ttc" id="classtgui_1_1Texture_html_aa434c72adfabf617afb06772960cc0f9"><div class="ttname"><a href="classtgui_1_1Texture.html#aa434c72adfabf617afb06772960cc0f9">tgui::Texture::isSmooth</a></div><div class="ttdeci">bool isSmooth() const </div><div class="ttdoc">Tell whether the smooth filter is enabled or not. </div><div class="ttdef"><b>Definition:</b> Texture.hpp:322</div></div>
</div><!-- fragment --></div><!-- contents -->
<!-- HTML footer for doxygen 1.8.10-->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated on Sat Nov 25 2017 17:32:41 for TGUI by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.11
</small></address>
<!-- BEGIN CUSTOM 3 -->
<!-- {% endraw %} -{{""}}-{{""}}>
</div>
{% include page_footer.ext %}
</div>
{% include footer.ext %}
<{{""}}!{{""}}-{{""}}- -->
<!-- END CUSTOM 3 -->
</body>
</html>
